import { Test, TestingModule } from '@nestjs/testing';
import { getRepositoryToken } from '@nestjs/typeorm';
import { AlbumController } from './album.controller';
import { AlbumService } from './album.service';
import { Album } from './album.entity';
import { Repository } from 'typeorm';

const mockAlbum = new Album();

describe('AlbumController', () => {
  let controller: AlbumController;
  let service: AlbumService;
  let repository: Repository<Album>;

  beforeEach(async () => {
    const module: TestingModule = await Test.createTestingModule({
      controllers: [AlbumController],
      providers: [
        AlbumService,
        {
          provide: getRepositoryToken(Album),
          useValue: {
            find: jest.fn().mockResolvedValue([mockAlbum]),
            findOne: jest.fn().mockResolvedValue(mockAlbum),
            create: jest.fn().mockResolvedValue(1),
            update: jest.fn().mockResolvedValue("Album updated successfully"),
            remove: jest.fn().mockResolvedValue(null),
          },
        },
      ]
    }).compile();

    controller = module.get<AlbumController>(AlbumController);
    service = module.get<AlbumService>(AlbumService);
    repository = module.get<Repository<Album>>(getRepositoryToken(Album));
  });

  it('should be defined', () => {
    expect(controller).toBeDefined();
  });

  describe('findAll', () => {
    it('should return an array of Albums', async () => {
      expect(await service.findAll()).toStrictEqual([mockAlbum]);
    })
  })

  describe('findOneById', () => {
    it('should return an Album', async () => {
      expect(await service.findOneById(1)).toStrictEqual(mockAlbum);
    })
  })
});
